Package com.io7m.montarre.api

# Class MPackageDeclaration.Builder

java.lang.Object
com.io7m.montarre.api.MPackageDeclaration.Builder

Enclosing class:
  `MPackageDeclaration`

public static final class MPackageDeclaration.Builder extends Object
Builds instances of type `MPackageDeclaration`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MPackageDeclaration`
  `build()`
  Builds a new `MPackageDeclaration`.
  `final MPackageDeclaration.Builder`
  `from(MPackageDeclarationType instance)`
  Fill a builder with attribute values from the provided `MPackageDeclarationType` instance.
  `final MPackageDeclaration.Builder`
  `setManifest(MManifestType manifest)`
  Initializes the value for the `manifest` attribute.
  `final MPackageDeclaration.Builder`
  `setMetadata(MMetadataType metadata)`
  Initializes the value for the `metadata` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final MPackageDeclaration.Builder from(MPackageDeclarationType instance)
    Fill a builder with attribute values from the provided `MPackageDeclarationType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMetadata

    public final MPackageDeclaration.Builder setMetadata(MMetadataType metadata)
    Initializes the value for the `metadata` attribute.
    Parameters:
      `metadata` - The value for metadata
    Returns:
      `this` builder for use in a chained invocation

  - ### setManifest

    public final MPackageDeclaration.Builder setManifest(MManifestType manifest)
    Initializes the value for the `manifest` attribute.
    Parameters:
      `manifest` - The value for manifest
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public MPackageDeclaration build()
    Builds a new `MPackageDeclaration`.
    Returns:
      An immutable instance of MPackageDeclaration
    Throws:
      `IllegalStateException` - if any required attributes are missing